import { getSetting } from "../../utils/settings";
import { displayActionBar } from "../../utils/utils";

export const kaboom_ability = {
  key: "kaboom",
  unlock_level: 5,
  enableTitle: false,
  description: () => {
    return [];
  },
  cooldown: (level) => getCooldown(level),
  onEnable: (data) => {
    const { player, skill, level } = data;
    let entities = player
      .getEntitiesFromViewDirection({ maxDistance: 30 })
      .filter((v) => v.entity.matches({ families: ["mob"] }));
    if (entities.length !== 0) {
      const explosion = player.dimension.spawnEntity(
        "pod_rpg:explosion",
        entities[0].entity.location
      );
      explosion.triggerEvent(
        `pod_rpg:kaboom${getSize(level)}${
          getSetting("explosion_damage")?.valueOf() === true ? "t" : "f"
        }`
      );
      skill.abilityCooldown.set(player, getCooldown(level) * 20, skill);
    } else {
      displayActionBar(player, 0, {
        rawtext: [{ translate: "pod_rpg.abilities.kaboom.no_entity" }],
      });
    }
  },
};

const getCooldown = (level) => {
  let cooldown = 60;
  if (level >= 1) cooldown -= 5;
  if (level >= 3) cooldown -= 5;
  if (level >= 5) cooldown -= 5;
  return cooldown;
};

const getSize = (level) => {
  let value = 0;
  if (level >= 2) value += 1;
  if (level >= 4) value += 1;
  return value;
};
