import { world } from "@minecraft/server";
import { addCoords, spawnParticle } from "../../utils/utils";

export const mount_ability = {
  key: "mount",
  unlock_level: 20,
  enableTitle: false,
  description: () => {
    return [];
  },
  onEnable: (data) => {
    const { player, level } = data;
    if (
      player.dimension.getEntities({
        tags: [`pod_rpg_owner:${player.id}`],
        location: player.location,
        maxDistance: 5,
      }).length !== 0
    )
      return;
    const mount = player.dimension.spawnEntity(
      "pod_rpg:mount",
      player.location
    );
    if (!mount || !mount.isValid()) return;
    world.playSound("mob.endermen.portal", mount.location);
    spawnParticle(mount.dimension, mount.location, "pod_rpg:mountcall");
    spawnParticle(
      mount.dimension,
      addCoords(mount.location, { x: 0, y: 1, z: 0 }),
      "pod_rpg:mountcall"
    );
    spawnParticle(
      mount.dimension,
      addCoords(mount.location, { x: 0, y: 2, z: 0 }),
      "pod_rpg:mountcall"
    );
    mount.addTag(`pod_rpg_owner:${player.id}`);
    mount.triggerEvent(`pod_rpg:speed${getSpeed(level)}`);
    mount.triggerEvent(`pod_rpg:jump${getJumpHeight(level)}`);
    mount.runCommand(`ride "${player.name}" start_riding @s teleport_ride`);
  },
};

const getSpeed = (level) => {
  let value = 0;
  if (level >= 1) value += 1;
  if (level >= 3) value += 1;
  if (level >= 5) value += 1;
  return value;
};

const getJumpHeight = (level) => {
  let value = 0;
  if (level >= 2) value += 1;
  if (level >= 4) value += 1;
  return value;
};
