export const swift_step_ability = {
  key: "swift_step",
  unlock_level: 5,
  enableTitle: true,
  description: (level) => {
    return [`${getAmplifier(level)}`, `${getDuration(level)}`];
  },
  cooldown: (level) => getCooldown(level),
  onEnable: (data) => {
    const { player, skill, level } = data;
    player.addEffect("speed", getDuration(level) * 20, {
      showParticles: false,
      amplifier: getAmplifier(level),
    });
    player.addEffect("jump_boost", getDuration(level) * 20, {
      showParticles: false,
      amplifier: getAmplifier(level),
    });
    skill.abilityCooldown.set(player, getCooldown(level) * 20, skill);
  },
};

const getAmplifier = (level) => {
  let value = 1;
  if (level >= 2) value += 1;
  if (level >= 4) value += 1;
  return value;
};
const getDuration = (level) => {
  let value = 10;
  if (level >= 3) value += 5;
  return value;
};
const getCooldown = (level) => {
  let cooldown = 60;
  if (level >= 1) cooldown -= 5;
  if (level >= 5) cooldown -= 10;
  return cooldown;
};
