export const saturation_ability = {
  key: "saturation",
  unlock_level: 5,
  enableTitle: true,
  description: (level) => {
    return [`${getSaturation(level)}`, `${getDuration(level)}`];
  },
  cooldown: (level) => getCooldown(level),
  onEnable: (data) => {
    const { player, skill, level } = data;
    player.addEffect("saturation", getDuration(level) * 20, {
      amplifier: getSaturation(level) - 1,
      showParticles: false,
    });
    skill.abilityCooldown.set(player, getCooldown(level) * 20, skill);
  },
};

const getSaturation = (level) => {
  let value = 1;
  if (level >= 3) value += 1;
  if (level >= 5) value += 1;
  return value;
};

const getCooldown = (level) => {
  let cooldown = 60;
  if (level >= 2) cooldown -= 10;
  if (level >= 4) cooldown -= 10;
  return cooldown;
};

const getDuration = (level) => {
  let duration = 5;
  if (level >= 1) duration += 5;
  return duration;
};
