export const haste_ability = {
  key: "haste",
  unlock_level: 5,
  enableTitle: true,
  description: (level) => {
    const hasteLevel = level >= 2 ? 3 : 2;
    return [`${hasteLevel}`, `${getDuration(level)}`];
  },
  cooldown: (level) => getCooldown(level),
  onEnable: (data) => {
    const { player, skill, level } = data;
    player.addEffect("haste", getDuration(level) * 20, {
      amplifier: level >= 2 ? 2 : 1,
      showParticles: false,
    });
    skill.abilityCooldown.set(player, getCooldown(level) * 20, skill);
  },
};

const getCooldown = (level) => {
  let cooldown = 60;
  if (level >= 3) cooldown -= 15;
  return cooldown;
};

const getDuration = (level) => {
  let duration = 10;
  if (level >= 1) duration += 5;
  if (level >= 4) duration += 5;
  if (level >= 5) duration += 10;
  return duration;
};
