import { system } from "@minecraft/server";
import { getAbilityName } from "../../utils/addonUtils";
import TimerUtil from "../../utils/cooldowns";

export const super_break_timer = new TimerUtil();

export const super_break_ability = {
  key: "super_break",
  unlock_level: 30,
  enableTitle: true,
  description: (level) => {
    return [`${getDuration(level)}`];
  },
  cooldown: (level) => getCooldown(level),
  onEnable: (data) => {
    const { player, skill, level } = data;

    super_break_timer.set(player.name, getDuration(level) * 20);
    super_break_timer.enableDisplay(player, () => {
      return {
        rawtext: [
          { text: "§p" },
          ...getAbilityName(super_break_ability),
          {
            text: ` ${(
              (super_break_timer.get(player.name) - system.currentTick) /
              20
            ).toFixed(1)}s`,
          },
        ],
      };
    });
    skill.abilityCooldown.set(player, getCooldown(level) * 20, skill);
  },
};

const getCooldown = (level) => {
  let cooldown = 120;
  if (level >= 2) cooldown -= 10;
  if (level >= 4) cooldown -= 10;
  return cooldown;
};

const getDuration = (level) => {
  let duration = 5;
  if (level >= 1) duration += 5;
  if (level >= 3) duration += 5;
  if (level >= 5) duration += 5;
  return duration;
};
