import { BlockPermutation, ItemStack, system, world } from "@minecraft/server";
import { blockMatches, spawnParticle } from "../../utils/utils";

export const regrowth_ability = {
  key: "regrowth",
  unlock_level: 5,
  description: (level) => {
    return [`${getChance(level)}%%`];
  },
};

const blocks = [
  "dirt",
  "grass",
  "dirt_with_roots",
  "podzol",
  "mud",
  "mycelium",
  "moss_block",
];

export const handleRegrowth = (block, treeType, level) => {
  if (block.isAir && blockMatches(block.below(), blocks)) {
    world.playSound("item.bone_meal.use", block.location, { volume: 3 });
    spawnParticle(block.dimension, block.center(), "pod_rpg:regrowth");
    system.runTimeout(() => {
      block.setPermutation(
        BlockPermutation.resolve(
          treeType.sapling.blockName,
          treeType.sapling.states
        )
      );
      for (let i = 0; i < (level >= 4 ? 3 : level >= 2 ? 2 : 1); i++) {
        if (getChance(level) >= Math.random() * 100) {
          block.dimension.spawnItem(
            new ItemStack("bone_meal", 1),
            block.location
          );
        }
      }
    }, 5);
  }
};

const getChance = (level) => {
  let value = 30;
  if (level >= 1) value += 10;
  if (level >= 3) value += 10;
  if (level >= 5) value += 10;
  return value;
};
