import { getSetting } from "../utils/settings";

const chunks = {};

export const isPlayerPlacedBlock = (location, permutation) => {
  if (getSetting("reduce_validations")?.valueOf() === true) return false;

  const { x, y, z } = location;
  const chunkX = chunks[Math.floor(x / 50)];
  const chunkZ = chunkX?.[Math.floor(z / 50)];
  const layerY = chunkZ?.[y];
  const layerX = layerY?.[x];
  const registeredPermutation = layerX?.[z];
  if (registeredPermutation) {
    if (registeredPermutation === permutation) return true;
  }
  return false;
};

export const setPlayerPlacedBlock = (block) => {
  if (getSetting("reduce_validations")?.valueOf() === true) return;
  const { x, y, z } = block.location;

  chunks[Math.floor(x / 50)] ??= {};
  const chunkX = chunks[Math.floor(x / 50)];

  chunkX[Math.floor(z / 50)] ??= {};
  const chunkZ = chunkX[Math.floor(z / 50)];

  chunkZ[y] ??= {};
  const layerY = chunkZ[y];

  layerY[x] ??= {};
  const layerX = layerY[x];

  layerX[z] = block.permutation;
};
