import { log } from "../utils/utils";

export const arrowRegistry = {};

export const handleArrowImpact = (event, type) => {
  if (event.projectile.typeId !== "minecraft:arrow") return;
  const arrow = arrowRegistry[event.projectile.id];
  if (arrow && arrow.onImpact) {
    try {
      arrow.onImpact(arrow, event, type);
    } catch (e) {
      if (e.name !== "LocationInUnloadedChunkError")
        log(`${e.name} on Arrow impact: ${e.message}`);
    }
  }
  arrowRegistry[event.projectile.id] = {};
};
