import { skills } from "../../main";
import { playerSneakEvent } from "../../utils/events";
import { getSetting } from "../../utils/settings";

const lastSneakData = {};

playerSneakEvent.subscribe((event) => {
  const doubleSneak =
    event.isSneaking &&
    lastSneakData[event.player.name] !== undefined &&
    event.tick - lastSneakData[event.player.name] <
      (getSetting("slower_double_click")?.valueOf() === true ? 30 : 15);

  if (event.isSneaking) lastSneakData[event.player.name] = event.tick;

  for (const skill of skills.filter(
    (skill) => skill.playerSneak !== undefined
  )) {
    skill.playerSneak.onEvent(event, doubleSneak);
  }
});
