import {
  enableAbilityTitle,
  getAbilityLevel,
  getSelectedAbility,
} from "../../utils/addonUtils";
import { triggerAbilityEvent } from "../../utils/events";

triggerAbilityEvent.subscribe((event) => {
  const { player, skill } = event;

  const ability = getSelectedAbility(player, skill);
  if (!ability || !ability.onEnable) return;
  if (skill.abilityCooldown.has(player.id + ability.key)) return;
  if (ability.enableTitle)
    enableAbilityTitle(player, ability, skill.primary_color);
  ability.onEnable({
    player: player,
    skill: skill,
    level: getAbilityLevel(player, skill, ability),
    eventData: event.eventData,
  });
});
