import { system, world } from "@minecraft/server";
import { playerShootArrowEvent } from "../utils/events";
import { getDistance } from "../utils/utils";

export const bowUseData = {};

world.afterEvents.entitySpawn.subscribe((event) => {
  if (event.entity.isValid() && event.entity.typeId === "minecraft:arrow") {
    const entityResult = event.entity.dimension.getEntities({
      location: event.entity.location,
      maxDistance: 10,
      type: "minecraft:player",
    });

    if (entityResult.length !== 0) {
      entityResult
        .sort((p) => getDistance(p.location, event.entity.location))
        .reverse();

      system.runTimeout(() => {
        for (const closePlayer of entityResult) {
          if (
            Math.abs(
              Math.abs(closePlayer.getRotation().y) -
                Math.abs(event.entity.getRotation().y)
            ) > 5
          )
            continue;
          const playerBowUseData = bowUseData[closePlayer.name];
          if (
            playerBowUseData &&
            system.currentTick === playerBowUseData.tick
          ) {
            playerBowUseData.tick = 0;
            playerShootArrowEvent.call({
              player: closePlayer,
              itemStack: playerBowUseData.bowItem,
              useDuration: playerBowUseData.useDuration,
              arrow: event.entity,
            });
            break;
          }
        }
      });
    }
  }
});
