import { world } from "@minecraft/server";
import { skills } from "../main";
import { isPlayerPlacedBlock } from "../data/playerPlacedBlocks";

world.afterEvents.playerBreakBlock.subscribe((event) => {
  const { itemStackBeforeBreak } = event;
  const filteredSkills = skills.filter(
    (skill) => skill.playerBreakBlock !== undefined
  );
  if (filteredSkills.length === 0) return;
  const isPlayerPlaced = isPlayerPlacedBlock(
    event.block.location,
    event.brokenBlockPermutation
  );
  for (const skill of filteredSkills) {
    if (skill.playerBreakBlock.disallowPlayerPlacedBlocks && isPlayerPlaced)
      continue;
    if (!skill.playerBreakBlock.item) {
      skill.playerBreakBlock.onEvent(event);
      return;
    }
    if (skill.playerBreakBlock.item && !itemStackBeforeBreak) continue;

    if (
      (skill.playerBreakBlock.item.tags &&
        skill.playerBreakBlock.item.tags.every((tag) =>
          itemStackBeforeBreak.hasTag(tag)
        )) ||
      (skill.playerBreakBlock.item.typeIds &&
        skill.playerBreakBlock.item.typeIds.includes(
          itemStackBeforeBreak.typeId
        ))
    ) {
      skill.playerBreakBlock.onEvent(event);
    }
  }
});
