import { ItemStack, world } from "@minecraft/server";

world.afterEvents.playerSpawn.subscribe((event) => {
  const { player, initialSpawn } = event;
  if (initialSpawn) {
    if (!player.hasTag("pod_rpg.receivedGuide")) {
      player.dimension.spawnItem(
        new ItemStack("pod_rpg:guide"),
        player.location
      );
      player.addTag("pod_rpg.receivedGuide");
    }
    if (
      player.hasTag("pod_rpg.disableMovement") &&
      player.runCommand("inputpermission set @s movement enabled")
        .successCount !== 0
    )
      player.removeTag("pod_rpg.disableMovement");
    if (
      player.hasTag("pod_rpg.customCamera") &&
      player.runCommand("camera @s clear").successCount !== 0
    )
      player.removeTag("pod_rpg.customCamera");
  }
});
