import { system } from "@minecraft/server";
import { showMainUi } from "../ui";
import { skills } from "../main";
import { getExpRequiredForLevel } from "../utils/addonUtils";
import { AbilityTimerUtil } from "../utils/cooldowns";

system.afterEvents.scriptEventReceive.subscribe((event) => {
  const { sourceEntity } = event;
  switch (event.id.replace("pod_rpg:", "")) {
    case "mainui":
      showMainUi(sourceEntity);
      break;
    //Functions for debugging
    case "clear_cooldown":
      for (const skill of skills) {
        skill.abilityCooldown = new AbilityTimerUtil();
      }
      break;
    case "value":
      if (event.message === "max_out_all") {
        for (const skill of skills) {
          event.sourceEntity.setDynamicProperty(
            `pod_rpg_${skill.key}_exp`,
            getExpRequiredForLevel(skill, 100)
          );
          for (const ability of skill.abilities) {
            event.sourceEntity.setDynamicProperty(
              `pod_rpg_${skill.key}_${ability.key}`,
              5
            );
          }
        }
        return;
      }
      sourceEntity.setDynamicProperty(
        "pod_rpg_" + event.message.split("=")[0],
        parseInt(event.message.split("=")[1])
      );
  }
});
