export default class PodcrashEvent {
  constructor() {
    this.listeners = [];
  }

  subscribe(listener) {
    this.listeners.push(listener);
  }

  call(eventData) {
    for (const listener of this.listeners) {
      listener(eventData);
    }
  }
}

export const playerJumpEvent = new PodcrashEvent();
export const playerSneakEvent = new PodcrashEvent();
export const triggerAbilityEvent = new PodcrashEvent();
export const playerShootArrowEvent = new PodcrashEvent();
